with Win32.WinUser;
with Win32.Winerror; use Win32.Winerror;
with Win32.Rpcdce; use Win32.Rpcdce;
with Win32.Winbase;
with System; use System;
with Ada.Unchecked_Deallocation;
with Ada.Unchecked_Conversion;

with Beep_Global; use Beep_Global;

package body BeepCom is

   procedure Free is new Ada.Unchecked_Deallocation(Beep_CoClass, Beep_CoClass_Pointer);

   function To_Beep_CoClass_Pointer is
      new Ada.Unchecked_Conversion (System.Address, Beep_CoClass_Pointer);
   function To_PVOID is
      new Ada.Unchecked_Conversion (System.Address, Win32.PVOID);
   function To_LPCSTR is
      new Ada.Unchecked_Conversion (System.Address, Win32.LPCSTR);

   procedure Free ( Pointer : in System.Address ) is
      X       : Beep_CoClass_Pointer;
      lResult : Win32.Long;
   begin
      X := To_Beep_CoClass_Pointer(Pointer);
      Free(X);
      lResult := Win32.Winbase.InterlockedDecrement(g_cComponents'Access);

      Can_Close;
   end Free;

   function QueryInterface  (
                This     : access Beep_CoClass;
                riid     : REFIID;
                ppvObject: access Win32.PVOID)
               return HRESULT is
   begin

      if riid.all = Beep_Global.IID_IUnknown then
         ppvObject.all := This.all'Address;
      elsif riid.all = Beep_Global.IID_IBeep then
         ppvObject.all := This.all'Address;
	else
         ppvObject.all := System.Null_Address;
         return E_NOINTERFACE;
	end if;

      This.m_cRef := This.m_cRef+1;

      return S_OK;
   end QueryInterface;

   function AddRef (
                This: access Beep_CoClass)
               return Win32.ULONG is
   begin
      This.m_cRef := This.m_cRef+1;

      return This.m_cRef;
   end AddRef;

   function Release (
                This: access Beep_CoClass)
               return Win32.ULONG is
   begin
	This.m_cRef := This.m_cRef-1;

	if This.m_cRef /=0 then
         return This.m_cRef;
      end if;

	Free(This.all'Address);

	return 0;
   end Release;

   function Beep (
                This: access Beep_CoClass)
               return HRESULT is
      RetValue    : Win32.Bool;
      BoxTitle    : Char_Array := "Beep" & nul;
      BoxMessage  : Char_Array := "Did you hear it?" & nul;
      iRetValue   : Win32.Int;
   begin
      RetValue := Win32.WinUser.MessageBeep(Win32.WinUser.MB_ICONEXCLAMATION);
      iRetValue := Win32.WinUser.MessageBox(
                  System.Null_Address,
                  To_LPCSTR(BoxMessage'Address),
                  To_LPCSTR(BoxTitle'Address),
                  Win32.WinUser.MB_YESNO);
      return S_OK;
   end Beep;

end BeepCom;