with win32.objbase; use win32.objbase;
with interfaces.c; use interfaces.c;

package Factory is

   subtype HRESULT is unsigned_long;

   -- Class Factory Object
   type Class_Factory;
   type Class_Factory_Pointer;

   type af_QueryInterface is access function (
               This     : access Class_Factory;
               riid     : REFIID;
               ppvObject: access Win32.PVOID)
              return HRESULT;
   pragma Convention(Stdcall, af_QueryInterface);

   type af_AddRef is access function (
               This: access Class_Factory)
              return Win32.ULONG;
   pragma Convention(Stdcall, af_AddRef);

   type af_Release is access function (
               This: access Class_Factory)
              return Win32.ULONG;
   pragma Convention(Stdcall, af_Release);

   type af_CreateInstance is access function (
               This     : access Class_Factory;
               pUnkOuter: access IUnknown;
               riid     : REFIID;
               ppvObject: access Win32.PVOID)
              return HRESULT;
   pragma Convention(Stdcall, af_CreateInstance);

   type af_LockServer is access function (
               This : access Class_Factory;
               fLock: Win32.BOOL)
              return HRESULT;
   pragma Convention(Stdcall, af_LockServer);

   function QueryInterface  (
                This     : access Class_Factory;
                riid     : REFIID;
                ppvObject: access Win32.PVOID)
               return HRESULT;
   pragma Convention(Stdcall, QueryInterface);

   function AddRef (
                This: access Class_Factory)
               return Win32.ULONG;
   pragma Convention(Stdcall, AddRef);

   function Release (
                This: access Class_Factory)
               return Win32.ULONG;
   pragma Convention(Stdcall, Release);

   function CreateInstance (
                This     : access Class_Factory;
                pUnkOuter: access IUnknown;
                riid     : REFIID;
                ppvObject: access Win32.PVOID)
               return HRESULT;
   pragma Convention(Stdcall, CreateInstance);

   function LockServer (
                This : access Class_Factory;
                fLock: Win32.BOOL)
               return HRESULT;
   pragma Convention(Stdcall, LockServer);

   type Class_Factory_Vtbl is
      record
         QueryInterface: af_QueryInterface := Factory.QueryInterface'Access;
         AddRef        : af_AddRef := Factory.AddRef'Access;
         Release       : af_Release := Factory.Release'Access;
         CreateInstance: af_CreateInstance := Factory.CreateInstance'Access;
         LockServer    : af_LockServer := Factory.LockServer'Access;
      end record;
   pragma Convention(C, Class_Factory_Vtbl);

   type Class_Factory_Vtbl_Pointer is access all Class_Factory_Vtbl;

   Vtbl : aliased Class_Factory_Vtbl;

   type Class_Factory is
      record
         lpVtbl : Class_Factory_Vtbl_Pointer := Vtbl'Access;
         m_cRef : Win32.ULONG := 1;
      end record;
   pragma Convention(C, Class_Factory);

   type Class_Factory_Pointer is access all Class_Factory;
end Factory;